// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/PathPointPredicted.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_POINT_PREDICTED__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_POINT_PREDICTED__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'DELTA_ALTITUDE_DEFAULT'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathPointPredicted__DELTA_ALTITUDE_DEFAULT = 12800
};

/// Constant 'ALTITUDE_CONFIDENCE_DEFAULT'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathPointPredicted__ALTITUDE_CONFIDENCE_DEFAULT = 15
};

// Include directives for member types
// Member 'delta_latitude'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_latitude__struct.h"
// Member 'delta_longitude'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_longitude__struct.h"
// Member 'horizontal_position_confidence'
#include "etsi_its_denm_ts_msgs/msg/detail/pos_confidence_ellipse__struct.h"
// Member 'delta_altitude'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_altitude__struct.h"
// Member 'altitude_confidence'
#include "etsi_its_denm_ts_msgs/msg/detail/altitude_confidence__struct.h"
// Member 'path_delta_time'
#include "etsi_its_denm_ts_msgs/msg/detail/path_delta_time_choice__struct.h"
// Member 'symmetric_area_offset'
// Member 'asymmetric_area_offset'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length9b__struct.h"

/// Struct defined in msg/PathPointPredicted in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__PathPointPredicted
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF defines a predicted offset position that can be used within a predicted path or trajectory, together with optional data to describe a path zone shape.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field deltaLatitude: the offset latitude with regards to a pre-defined reference position.
  ///  *
  ///  * @field deltaLongitude: the offset longitude with regards to a pre-defined reference position.
  ///  *
  ///  * @field horizontalPositionConfidence: the optional confidence value associated to the horizontal geographical position.
  ///  *
  ///  * @field deltaAltitude: the optional offset altitude with regards to a pre-defined reference position, with default value unavailable.
  ///  *
  ///  * @field altitudeConfidence: the optional confidence value associated to the altitude value of the geographical position, with default value unavailable.
  ///  *
  ///  * @field pathDeltaTime: the optional travel time to the waypoint from the predefined reference position.
  ///
  ///  * @field symmetricAreaOffset: the optional symmetric offset to generate a shape, see Annex D for details.
  ///  *
  ///  * @field asymmetricAreaOffset: the optional asymmetric offset to generate a shape, see Annex D for details.
  ///  *
  ///  * @category GeoReference information
  ///  * @revision: Created in V2.1.1, type of pathDeltaTime changed and optionality added, fields symmetricAreaOffset and asymmetricAreaOffset added in V2.2.1
  ///  */
  /// PathPointPredicted::= SEQUENCE {
  ///   deltaLatitude                 DeltaLatitude,
  ///   deltaLongitude                DeltaLongitude,
  ///   horizontalPositionConfidence  PosConfidenceEllipse OPTIONAL,
  ///   deltaAltitude                 DeltaAltitude DEFAULT unavailable,
  ///   altitudeConfidence            AltitudeConfidence DEFAULT unavailable,
  ///   pathDeltaTime                 PathDeltaTimeChoice OPTIONAL,
  ///   symmetricAreaOffset           StandardLength9b OPTIONAL,
  ///   asymmetricAreaOffset          StandardLength9b OPTIONAL,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__DeltaLatitude delta_latitude;
  etsi_its_denm_ts_msgs__msg__DeltaLongitude delta_longitude;
  etsi_its_denm_ts_msgs__msg__PosConfidenceEllipse horizontal_position_confidence;
  bool horizontal_position_confidence_is_present;
  etsi_its_denm_ts_msgs__msg__DeltaAltitude delta_altitude;
  etsi_its_denm_ts_msgs__msg__AltitudeConfidence altitude_confidence;
  etsi_its_denm_ts_msgs__msg__PathDeltaTimeChoice path_delta_time;
  bool path_delta_time_is_present;
  etsi_its_denm_ts_msgs__msg__StandardLength9b symmetric_area_offset;
  bool symmetric_area_offset_is_present;
  etsi_its_denm_ts_msgs__msg__StandardLength9b asymmetric_area_offset;
  bool asymmetric_area_offset_is_present;
} etsi_its_denm_ts_msgs__msg__PathPointPredicted;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__PathPointPredicted.
typedef struct etsi_its_denm_ts_msgs__msg__PathPointPredicted__Sequence
{
  etsi_its_denm_ts_msgs__msg__PathPointPredicted * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__PathPointPredicted__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_POINT_PREDICTED__STRUCT_H_
